import java.io.File;

import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;

import javax.xml.transform.OutputKeys;
import javax.xml.transform.Transformer;
import javax.xml.transform.TransformerFactory;

import javax.xml.transform.dom.DOMSource;

import javax.xml.transform.stream.StreamResult;

import org.w3c.dom.Document;
import org.w3c.dom.Element;
import org.w3c.dom.NodeList;
import org.w3c.dom.Node;

public class GLIAssociate
{
    public static void main(String[] args)
    {
	String ekitDir = System.getProperty("user.dir");

	String gliConfigFilename = System.getProperty("user.home") + System.getProperty("file.separator");
	if (System.getProperty("os.name").contains("Windows")) {
	    gliConfigFilename += "Application Data" + System.getProperty("file.separator") + "Greenstone" + System.getProperty("file.separator") + "GLI" + System.getProperty("file.separator") + "config.xml";
	}
	else {
	    gliConfigFilename += ".gli" + System.getProperty("file.separator") + "config.xml";
	}

	try{
	    DocumentBuilderFactory dbf = DocumentBuilderFactory.newInstance();
	    DocumentBuilder db = dbf.newDocumentBuilder();
	    File docFile = new File(gliConfigFilename);
	    Document doc = db.parse(docFile);

	    Element root = doc.getDocumentElement();
	    NodeList assocEntries = root.getElementsByTagName("Entry");

	    Element htmlEntry = null;
	    Element htmEntry = null;
	    for(int i = 0; i < assocEntries.getLength(); i++){
		Element currentElement = (Element)assocEntries.item(i);
		if(currentElement.getAttribute("extension").equals("html")){
		    htmlEntry = currentElement;
		}
		else if(currentElement.getAttribute("extension").equals("htm")){
		    htmEntry = currentElement;
		}
	    }

	    while(htmlEntry.getFirstChild() != null){
		htmlEntry.removeChild(htmlEntry.getFirstChild());
	    }

	    while(htmEntry.getFirstChild() != null){
		htmEntry.removeChild(htmEntry.getFirstChild());
	    }
	    
	    Node commandString = doc.createTextNode("java -jar " + ekitDir + System.getProperty("file.separator") + "ekit.jar -x -s -f%1");
	    htmlEntry.appendChild(commandString);
	    htmEntry.appendChild(commandString.cloneNode(false));

	    TransformerFactory tf = TransformerFactory.newInstance();
	    Transformer transformer = tf.newTransformer();
	    transformer.setOutputProperty(OutputKeys.INDENT, "yes");
	    
	    StreamResult result = new StreamResult(docFile);
	    DOMSource source = new DOMSource(doc);
	    transformer.transform(source, result);

	    System.out.println("Ekit has been sucessfully associated with GLI");
	}
	catch(Exception ex){
	    System.out.println("There was an error while associating Ekit with GLI, this is most likely to be because the system cannot find the configuration file required. If you have not yet run GLI for the first time then doing so will most likely fix this problem.");
	    ex.printStackTrace();
	}
    }
}